﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace ConsoleApplication2
{
    class Program
    {
        static void Main(string[] args)
        {

            var s = new Stopwatch();
            string txt128 = // 128 bytes (8x = 1 KB)
                "Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nullam suscipit dictum arcu. Cras feugiat libero ut lectus. Donec sed.";

            int OneMega = 1024*1024;
            int Quantity = 1*OneMega;
            int NumOfTxt128 = Quantity/128;

            Console.WriteLine("String Concatenation\n");

            var result = string.Empty;
            long memory = GC.GetTotalMemory(true);
            s.Reset();
            s.Start();
            for (var i = 0; i <= NumOfTxt128; i++)
                result += txt128;
            s.Stop();

            Console.WriteLine("Size of Result = "+result.Length/OneMega+" MB");
            Console.WriteLine("128 Bytes text has been concatenated "+NumOfTxt128+" times");
            Console.WriteLine("Elapsed time : "+s.Elapsed);
            long currentMemory = GC.GetTotalMemory(false);
            long stress = currentMemory - memory;
            Console.WriteLine("Memory stress : "+stress.ToString("### ### ##0"));
            Console.WriteLine("Memory before {0} and after {1}",memory,currentMemory);

            Console.WriteLine("\n\nStringBuilder\n");

            result = string.Empty;
            GC.Collect();
            memory = GC.GetTotalMemory(true);
            s.Reset();
            s.Start();
            var sb = new StringBuilder();
            for (var i = 0; i <= NumOfTxt128; i++)
                sb.Append(txt128);
            result = sb.ToString();
            s.Stop();

            Console.WriteLine("Size of Result = " + result.Length / OneMega + " MB");
            Console.WriteLine("128 Bytes text has been concatenated " + NumOfTxt128 + " times");
            Console.WriteLine("Elapsed time : " + s.Elapsed);
            currentMemory = GC.GetTotalMemory(false);
            stress = currentMemory - memory;
            Console.WriteLine("Memory stress : " + stress.ToString("### ### ##0"));
            Console.WriteLine("Memory before {0} and after {1}", memory, currentMemory);


            Console.WriteLine("\n\nString Concatenation 1000xsmall work\n");
            result = string.Empty;
            GC.Collect();
            memory = GC.GetTotalMemory(true);
            s.Reset();
            s.Start();
            for (var i = 0; i <= 1000; i++)
            {
                result = txt128 + txt128;
                result += txt128;
                result += txt128; // 512 Bytes
            }
            s.Stop();

            Console.WriteLine("1000 string concatenation (4*128 = 512 Bytes)");
            Console.WriteLine("Elapsed time : " + s.Elapsed);
            currentMemory = GC.GetTotalMemory(false);
            stress = currentMemory - memory;
            Console.WriteLine("Memory stress : " + stress.ToString("### ### ##0"));
            Console.WriteLine("Memory before {0} and after {1}", memory, currentMemory);


            Console.WriteLine("\n\nStringBuilder Concatenation 1000xsmall work\n");
            result = string.Empty;
            GC.Collect();
            memory = GC.GetTotalMemory(true);
            s.Reset();
            s.Start();
            for (var i = 0; i <= 1000; i++)
            {
                sb = new StringBuilder();
                sb.Append(txt128);
                sb.Append(txt128);
                sb.Append(txt128);
                sb.Append(txt128);
                result = sb.ToString(); // 512 Bytes
            }
            s.Stop();

            Console.WriteLine("1000 StringBuilder concatenation (4*128 = 512 Bytes)");
            Console.WriteLine("Elapsed time : " + s.Elapsed);
            currentMemory = GC.GetTotalMemory(false);
            stress = currentMemory - memory;
            Console.WriteLine("Memory stress : " + stress.ToString("### ### ##0"));
            Console.WriteLine("Memory before {0} and after {1}", memory, currentMemory);

            Console.ReadLine();


        }
    }
}
